// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from rc_reason_msgs:srv/DetectFillingLevel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/detect_filling_level__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/detail/detect_filling_level__struct.h"
#include "rc_reason_msgs/srv/detail/detect_filling_level__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "geometry_msgs/msg/detail/pose__functions.h"  // robot_pose
#include "rc_reason_msgs/msg/detail/grid_size__functions.h"  // filling_level_cell_count
#include "rosidl_runtime_c/string.h"  // load_carrier_ids, pose_frame, region_of_interest_2d_id, region_of_interest_id
#include "rosidl_runtime_c/string_functions.h"  // load_carrier_ids, pose_frame, region_of_interest_2d_id, region_of_interest_id

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_geometry_msgs__msg__Pose(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_geometry_msgs__msg__Pose(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose)();
size_t get_serialized_size_rc_reason_msgs__msg__GridSize(
  const void * untyped_ros_message,
  size_t current_alignment);

size_t max_serialized_size_rc_reason_msgs__msg__GridSize(
  bool & full_bounded,
  size_t current_alignment);

const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, GridSize)();


using _DetectFillingLevel_Request__ros_msg_type = rc_reason_msgs__srv__DetectFillingLevel_Request;

static bool _DetectFillingLevel_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _DetectFillingLevel_Request__ros_msg_type * ros_message = static_cast<const _DetectFillingLevel_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: pose_frame
  {
    const rosidl_runtime_c__String * str = &ros_message->pose_frame;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: region_of_interest_id
  {
    const rosidl_runtime_c__String * str = &ros_message->region_of_interest_id;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: region_of_interest_2d_id
  {
    const rosidl_runtime_c__String * str = &ros_message->region_of_interest_2d_id;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: load_carrier_ids
  {
    size_t size = ros_message->load_carrier_ids.size;
    auto array_ptr = ros_message->load_carrier_ids.data;
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; ++i) {
      const rosidl_runtime_c__String * str = &array_ptr[i];
      if (str->capacity == 0 || str->capacity <= str->size) {
        fprintf(stderr, "string capacity not greater than size\n");
        return false;
      }
      if (str->data[str->size] != '\0') {
        fprintf(stderr, "string not null-terminated\n");
        return false;
      }
      cdr << str->data;
    }
  }

  // Field name: robot_pose
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->robot_pose, cdr))
    {
      return false;
    }
  }

  // Field name: filling_level_cell_count
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, GridSize
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->filling_level_cell_count, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _DetectFillingLevel_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _DetectFillingLevel_Request__ros_msg_type * ros_message = static_cast<_DetectFillingLevel_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: pose_frame
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->pose_frame.data) {
      rosidl_runtime_c__String__init(&ros_message->pose_frame);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->pose_frame,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'pose_frame'\n");
      return false;
    }
  }

  // Field name: region_of_interest_id
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->region_of_interest_id.data) {
      rosidl_runtime_c__String__init(&ros_message->region_of_interest_id);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->region_of_interest_id,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'region_of_interest_id'\n");
      return false;
    }
  }

  // Field name: region_of_interest_2d_id
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->region_of_interest_2d_id.data) {
      rosidl_runtime_c__String__init(&ros_message->region_of_interest_2d_id);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->region_of_interest_2d_id,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'region_of_interest_2d_id'\n");
      return false;
    }
  }

  // Field name: load_carrier_ids
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->load_carrier_ids.data) {
      rosidl_runtime_c__String__Sequence__fini(&ros_message->load_carrier_ids);
    }
    if (!rosidl_runtime_c__String__Sequence__init(&ros_message->load_carrier_ids, size)) {
      fprintf(stderr, "failed to create array for field 'load_carrier_ids'");
      return false;
    }
    auto array_ptr = ros_message->load_carrier_ids.data;
    for (size_t i = 0; i < size; ++i) {
      std::string tmp;
      cdr >> tmp;
      auto & ros_i = array_ptr[i];
      if (!ros_i.data) {
        rosidl_runtime_c__String__init(&ros_i);
      }
      bool succeeded = rosidl_runtime_c__String__assign(
        &ros_i,
        tmp.c_str());
      if (!succeeded) {
        fprintf(stderr, "failed to assign string into field 'load_carrier_ids'\n");
        return false;
      }
    }
  }

  // Field name: robot_pose
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->robot_pose))
    {
      return false;
    }
  }

  // Field name: filling_level_cell_count
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, GridSize
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->filling_level_cell_count))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Request(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _DetectFillingLevel_Request__ros_msg_type * ros_message = static_cast<const _DetectFillingLevel_Request__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name pose_frame
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->pose_frame.size + 1);
  // field.name region_of_interest_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->region_of_interest_id.size + 1);
  // field.name region_of_interest_2d_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->region_of_interest_2d_id.size + 1);
  // field.name load_carrier_ids
  {
    size_t array_size = ros_message->load_carrier_ids.size;
    auto array_ptr = ros_message->load_carrier_ids.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (array_ptr[index].size + 1);
    }
  }
  // field.name robot_pose

  current_alignment += get_serialized_size_geometry_msgs__msg__Pose(
    &(ros_message->robot_pose), current_alignment);
  // field.name filling_level_cell_count

  current_alignment += get_serialized_size_rc_reason_msgs__msg__GridSize(
    &(ros_message->filling_level_cell_count), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _DetectFillingLevel_Request__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Request(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Request(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: pose_frame
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: region_of_interest_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: region_of_interest_2d_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: load_carrier_ids
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: robot_pose
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_geometry_msgs__msg__Pose(
        full_bounded, current_alignment);
    }
  }
  // member: filling_level_cell_count
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_reason_msgs__msg__GridSize(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _DetectFillingLevel_Request__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Request(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_DetectFillingLevel_Request = {
  "rc_reason_msgs::srv",
  "DetectFillingLevel_Request",
  _DetectFillingLevel_Request__cdr_serialize,
  _DetectFillingLevel_Request__cdr_deserialize,
  _DetectFillingLevel_Request__get_serialized_size,
  _DetectFillingLevel_Request__max_serialized_size
};

static rosidl_message_type_support_t _DetectFillingLevel_Request__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_DetectFillingLevel_Request,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectFillingLevel_Request)() {
  return &_DetectFillingLevel_Request__type_support;
}

#if defined(__cplusplus)
}
#endif

// already included above
// #include <cassert>
// already included above
// #include <limits>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_filling_level__struct.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_filling_level__functions.h"
// already included above
// #include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "builtin_interfaces/msg/detail/time__functions.h"  // timestamp
#include "rc_common_msgs/msg/detail/return_code__functions.h"  // return_code
#include "rc_reason_msgs/msg/detail/load_carrier_with_filling_level__functions.h"  // load_carriers

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_builtin_interfaces__msg__Time(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_builtin_interfaces__msg__Time(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time)();
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_rc_common_msgs__msg__ReturnCode(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_rc_common_msgs__msg__ReturnCode(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode)();
size_t get_serialized_size_rc_reason_msgs__msg__LoadCarrierWithFillingLevel(
  const void * untyped_ros_message,
  size_t current_alignment);

size_t max_serialized_size_rc_reason_msgs__msg__LoadCarrierWithFillingLevel(
  bool & full_bounded,
  size_t current_alignment);

const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, LoadCarrierWithFillingLevel)();


using _DetectFillingLevel_Response__ros_msg_type = rc_reason_msgs__srv__DetectFillingLevel_Response;

static bool _DetectFillingLevel_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _DetectFillingLevel_Response__ros_msg_type * ros_message = static_cast<const _DetectFillingLevel_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: timestamp
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->timestamp, cdr))
    {
      return false;
    }
  }

  // Field name: load_carriers
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, LoadCarrierWithFillingLevel
      )()->data);
    size_t size = ros_message->load_carriers.size;
    auto array_ptr = ros_message->load_carriers.data;
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_serialize(
          &array_ptr[i], cdr))
      {
        return false;
      }
    }
  }

  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->return_code, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _DetectFillingLevel_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _DetectFillingLevel_Response__ros_msg_type * ros_message = static_cast<_DetectFillingLevel_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: timestamp
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->timestamp))
    {
      return false;
    }
  }

  // Field name: load_carriers
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, LoadCarrierWithFillingLevel
      )()->data);
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->load_carriers.data) {
      rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__fini(&ros_message->load_carriers);
    }
    if (!rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__init(&ros_message->load_carriers, size)) {
      fprintf(stderr, "failed to create array for field 'load_carriers'");
      return false;
    }
    auto array_ptr = ros_message->load_carriers.data;
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_deserialize(
          cdr, &array_ptr[i]))
      {
        return false;
      }
    }
  }

  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->return_code))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Response(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _DetectFillingLevel_Response__ros_msg_type * ros_message = static_cast<const _DetectFillingLevel_Response__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name timestamp

  current_alignment += get_serialized_size_builtin_interfaces__msg__Time(
    &(ros_message->timestamp), current_alignment);
  // field.name load_carriers
  {
    size_t array_size = ros_message->load_carriers.size;
    auto array_ptr = ros_message->load_carriers.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += get_serialized_size_rc_reason_msgs__msg__LoadCarrierWithFillingLevel(
        &array_ptr[index], current_alignment);
    }
  }
  // field.name return_code

  current_alignment += get_serialized_size_rc_common_msgs__msg__ReturnCode(
    &(ros_message->return_code), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _DetectFillingLevel_Response__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Response(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Response(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: timestamp
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_builtin_interfaces__msg__Time(
        full_bounded, current_alignment);
    }
  }
  // member: load_carriers
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_reason_msgs__msg__LoadCarrierWithFillingLevel(
        full_bounded, current_alignment);
    }
  }
  // member: return_code
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_common_msgs__msg__ReturnCode(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _DetectFillingLevel_Response__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__DetectFillingLevel_Response(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_DetectFillingLevel_Response = {
  "rc_reason_msgs::srv",
  "DetectFillingLevel_Response",
  _DetectFillingLevel_Response__cdr_serialize,
  _DetectFillingLevel_Response__cdr_deserialize,
  _DetectFillingLevel_Response__get_serialized_size,
  _DetectFillingLevel_Response__max_serialized_size
};

static rosidl_message_type_support_t _DetectFillingLevel_Response__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_DetectFillingLevel_Response,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectFillingLevel_Response)() {
  return &_DetectFillingLevel_Response__type_support;
}

#if defined(__cplusplus)
}
#endif

#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/detect_filling_level.h"

#if defined(__cplusplus)
extern "C"
{
#endif

static service_type_support_callbacks_t DetectFillingLevel__callbacks = {
  "rc_reason_msgs::srv",
  "DetectFillingLevel",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectFillingLevel_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectFillingLevel_Response)(),
};

static rosidl_service_type_support_t DetectFillingLevel__handle = {
  rosidl_typesupport_fastrtps_c__identifier,
  &DetectFillingLevel__callbacks,
  get_service_typesupport_handle_function,
};

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectFillingLevel)() {
  return &DetectFillingLevel__handle;
}

#if defined(__cplusplus)
}
#endif
