// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from rc_reason_msgs:srv/DetectTags.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/detect_tags__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/detail/detect_tags__struct.h"
#include "rc_reason_msgs/srv/detail/detect_tags__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "geometry_msgs/msg/detail/pose__functions.h"  // robot_pose
#include "rc_reason_msgs/msg/detail/tag__functions.h"  // tags
#include "rosidl_runtime_c/string.h"  // pose_frame
#include "rosidl_runtime_c/string_functions.h"  // pose_frame

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_geometry_msgs__msg__Pose(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_geometry_msgs__msg__Pose(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose)();
size_t get_serialized_size_rc_reason_msgs__msg__Tag(
  const void * untyped_ros_message,
  size_t current_alignment);

size_t max_serialized_size_rc_reason_msgs__msg__Tag(
  bool & full_bounded,
  size_t current_alignment);

const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, Tag)();


using _DetectTags_Request__ros_msg_type = rc_reason_msgs__srv__DetectTags_Request;

static bool _DetectTags_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _DetectTags_Request__ros_msg_type * ros_message = static_cast<const _DetectTags_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: tags
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, Tag
      )()->data);
    size_t size = ros_message->tags.size;
    auto array_ptr = ros_message->tags.data;
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_serialize(
          &array_ptr[i], cdr))
      {
        return false;
      }
    }
  }

  // Field name: pose_frame
  {
    const rosidl_runtime_c__String * str = &ros_message->pose_frame;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: robot_pose
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->robot_pose, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _DetectTags_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _DetectTags_Request__ros_msg_type * ros_message = static_cast<_DetectTags_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: tags
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, Tag
      )()->data);
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->tags.data) {
      rc_reason_msgs__msg__Tag__Sequence__fini(&ros_message->tags);
    }
    if (!rc_reason_msgs__msg__Tag__Sequence__init(&ros_message->tags, size)) {
      fprintf(stderr, "failed to create array for field 'tags'");
      return false;
    }
    auto array_ptr = ros_message->tags.data;
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_deserialize(
          cdr, &array_ptr[i]))
      {
        return false;
      }
    }
  }

  // Field name: pose_frame
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->pose_frame.data) {
      rosidl_runtime_c__String__init(&ros_message->pose_frame);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->pose_frame,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'pose_frame'\n");
      return false;
    }
  }

  // Field name: robot_pose
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->robot_pose))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__DetectTags_Request(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _DetectTags_Request__ros_msg_type * ros_message = static_cast<const _DetectTags_Request__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name tags
  {
    size_t array_size = ros_message->tags.size;
    auto array_ptr = ros_message->tags.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += get_serialized_size_rc_reason_msgs__msg__Tag(
        &array_ptr[index], current_alignment);
    }
  }
  // field.name pose_frame
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->pose_frame.size + 1);
  // field.name robot_pose

  current_alignment += get_serialized_size_geometry_msgs__msg__Pose(
    &(ros_message->robot_pose), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _DetectTags_Request__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__DetectTags_Request(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__DetectTags_Request(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: tags
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_reason_msgs__msg__Tag(
        full_bounded, current_alignment);
    }
  }
  // member: pose_frame
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: robot_pose
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_geometry_msgs__msg__Pose(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _DetectTags_Request__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__DetectTags_Request(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_DetectTags_Request = {
  "rc_reason_msgs::srv",
  "DetectTags_Request",
  _DetectTags_Request__cdr_serialize,
  _DetectTags_Request__cdr_deserialize,
  _DetectTags_Request__get_serialized_size,
  _DetectTags_Request__max_serialized_size
};

static rosidl_message_type_support_t _DetectTags_Request__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_DetectTags_Request,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectTags_Request)() {
  return &_DetectTags_Request__type_support;
}

#if defined(__cplusplus)
}
#endif

// already included above
// #include <cassert>
// already included above
// #include <limits>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__struct.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__functions.h"
// already included above
// #include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "builtin_interfaces/msg/detail/time__functions.h"  // timestamp
#include "rc_common_msgs/msg/detail/return_code__functions.h"  // return_code
#include "rc_reason_msgs/msg/detail/detected_tag__functions.h"  // tags

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_builtin_interfaces__msg__Time(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_builtin_interfaces__msg__Time(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time)();
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_rc_common_msgs__msg__ReturnCode(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_rc_common_msgs__msg__ReturnCode(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode)();
size_t get_serialized_size_rc_reason_msgs__msg__DetectedTag(
  const void * untyped_ros_message,
  size_t current_alignment);

size_t max_serialized_size_rc_reason_msgs__msg__DetectedTag(
  bool & full_bounded,
  size_t current_alignment);

const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, DetectedTag)();


using _DetectTags_Response__ros_msg_type = rc_reason_msgs__srv__DetectTags_Response;

static bool _DetectTags_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _DetectTags_Response__ros_msg_type * ros_message = static_cast<const _DetectTags_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: tags
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, DetectedTag
      )()->data);
    size_t size = ros_message->tags.size;
    auto array_ptr = ros_message->tags.data;
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_serialize(
          &array_ptr[i], cdr))
      {
        return false;
      }
    }
  }

  // Field name: timestamp
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->timestamp, cdr))
    {
      return false;
    }
  }

  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->return_code, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _DetectTags_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _DetectTags_Response__ros_msg_type * ros_message = static_cast<_DetectTags_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: tags
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, DetectedTag
      )()->data);
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->tags.data) {
      rc_reason_msgs__msg__DetectedTag__Sequence__fini(&ros_message->tags);
    }
    if (!rc_reason_msgs__msg__DetectedTag__Sequence__init(&ros_message->tags, size)) {
      fprintf(stderr, "failed to create array for field 'tags'");
      return false;
    }
    auto array_ptr = ros_message->tags.data;
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_deserialize(
          cdr, &array_ptr[i]))
      {
        return false;
      }
    }
  }

  // Field name: timestamp
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->timestamp))
    {
      return false;
    }
  }

  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->return_code))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__DetectTags_Response(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _DetectTags_Response__ros_msg_type * ros_message = static_cast<const _DetectTags_Response__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name tags
  {
    size_t array_size = ros_message->tags.size;
    auto array_ptr = ros_message->tags.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += get_serialized_size_rc_reason_msgs__msg__DetectedTag(
        &array_ptr[index], current_alignment);
    }
  }
  // field.name timestamp

  current_alignment += get_serialized_size_builtin_interfaces__msg__Time(
    &(ros_message->timestamp), current_alignment);
  // field.name return_code

  current_alignment += get_serialized_size_rc_common_msgs__msg__ReturnCode(
    &(ros_message->return_code), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _DetectTags_Response__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__DetectTags_Response(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__DetectTags_Response(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: tags
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_reason_msgs__msg__DetectedTag(
        full_bounded, current_alignment);
    }
  }
  // member: timestamp
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_builtin_interfaces__msg__Time(
        full_bounded, current_alignment);
    }
  }
  // member: return_code
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_common_msgs__msg__ReturnCode(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _DetectTags_Response__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__DetectTags_Response(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_DetectTags_Response = {
  "rc_reason_msgs::srv",
  "DetectTags_Response",
  _DetectTags_Response__cdr_serialize,
  _DetectTags_Response__cdr_deserialize,
  _DetectTags_Response__get_serialized_size,
  _DetectTags_Response__max_serialized_size
};

static rosidl_message_type_support_t _DetectTags_Response__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_DetectTags_Response,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectTags_Response)() {
  return &_DetectTags_Response__type_support;
}

#if defined(__cplusplus)
}
#endif

#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/detect_tags.h"

#if defined(__cplusplus)
extern "C"
{
#endif

static service_type_support_callbacks_t DetectTags__callbacks = {
  "rc_reason_msgs::srv",
  "DetectTags",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectTags_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectTags_Response)(),
};

static rosidl_service_type_support_t DetectTags__handle = {
  rosidl_typesupport_fastrtps_c__identifier,
  &DetectTags__callbacks,
  get_service_typesupport_handle_function,
};

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DetectTags)() {
  return &DetectTags__handle;
}

#if defined(__cplusplus)
}
#endif
