// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rc_reason_msgs:msg/SilhouetteMatchObject.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/silhouette_match_object__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rc_reason_msgs/msg/detail/silhouette_match_object__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace rc_reason_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::msg::SilhouetteMatchObject & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: object_id
  cdr << ros_message.object_id;
  // Member: region_of_interest_2d_id
  cdr << ros_message.region_of_interest_2d_id;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::msg::SilhouetteMatchObject & ros_message)
{
  // Member: object_id
  cdr >> ros_message.object_id;

  // Member: region_of_interest_2d_id
  cdr >> ros_message.region_of_interest_2d_id;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::msg::SilhouetteMatchObject & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: object_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.object_id.size() + 1);
  // Member: region_of_interest_2d_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.region_of_interest_2d_id.size() + 1);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_SilhouetteMatchObject(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: object_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: region_of_interest_2d_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  return current_alignment - initial_alignment;
}

static bool _SilhouetteMatchObject__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::msg::SilhouetteMatchObject *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _SilhouetteMatchObject__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::msg::SilhouetteMatchObject *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _SilhouetteMatchObject__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::msg::SilhouetteMatchObject *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _SilhouetteMatchObject__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_SilhouetteMatchObject(full_bounded, 0);
}

static message_type_support_callbacks_t _SilhouetteMatchObject__callbacks = {
  "rc_reason_msgs::msg",
  "SilhouetteMatchObject",
  _SilhouetteMatchObject__cdr_serialize,
  _SilhouetteMatchObject__cdr_deserialize,
  _SilhouetteMatchObject__get_serialized_size,
  _SilhouetteMatchObject__max_serialized_size
};

static rosidl_message_type_support_t _SilhouetteMatchObject__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SilhouetteMatchObject__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::msg::SilhouetteMatchObject>()
{
  return &rc_reason_msgs::msg::typesupport_fastrtps_cpp::_SilhouetteMatchObject__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, msg, SilhouetteMatchObject)() {
  return &rc_reason_msgs::msg::typesupport_fastrtps_cpp::_SilhouetteMatchObject__handle;
}

#ifdef __cplusplus
}
#endif
