// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rc_reason_msgs:srv/DetectLoadCarriers.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/detect_load_carriers__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rc_reason_msgs/srv/detail/detect_load_carriers__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace geometry_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const geometry_msgs::msg::Pose &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  geometry_msgs::msg::Pose &);
size_t get_serialized_size(
  const geometry_msgs::msg::Pose &,
  size_t current_alignment);
size_t
max_serialized_size_Pose(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace geometry_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::srv::DetectLoadCarriers_Request & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: pose_frame
  cdr << ros_message.pose_frame;
  // Member: region_of_interest_id
  cdr << ros_message.region_of_interest_id;
  // Member: region_of_interest_2d_id
  cdr << ros_message.region_of_interest_2d_id;
  // Member: load_carrier_ids
  {
    cdr << ros_message.load_carrier_ids;
  }
  // Member: robot_pose
  geometry_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.robot_pose,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::srv::DetectLoadCarriers_Request & ros_message)
{
  // Member: pose_frame
  cdr >> ros_message.pose_frame;

  // Member: region_of_interest_id
  cdr >> ros_message.region_of_interest_id;

  // Member: region_of_interest_2d_id
  cdr >> ros_message.region_of_interest_2d_id;

  // Member: load_carrier_ids
  {
    cdr >> ros_message.load_carrier_ids;
  }

  // Member: robot_pose
  geometry_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.robot_pose);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::srv::DetectLoadCarriers_Request & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: pose_frame
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.pose_frame.size() + 1);
  // Member: region_of_interest_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.region_of_interest_id.size() + 1);
  // Member: region_of_interest_2d_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.region_of_interest_2d_id.size() + 1);
  // Member: load_carrier_ids
  {
    size_t array_size = ros_message.load_carrier_ids.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (ros_message.load_carrier_ids[index].size() + 1);
    }
  }
  // Member: robot_pose

  current_alignment +=
    geometry_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.robot_pose, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_DetectLoadCarriers_Request(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: pose_frame
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: region_of_interest_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: region_of_interest_2d_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: load_carrier_ids
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: robot_pose
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        geometry_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Pose(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _DetectLoadCarriers_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::DetectLoadCarriers_Request *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _DetectLoadCarriers_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::srv::DetectLoadCarriers_Request *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _DetectLoadCarriers_Request__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::DetectLoadCarriers_Request *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _DetectLoadCarriers_Request__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_DetectLoadCarriers_Request(full_bounded, 0);
}

static message_type_support_callbacks_t _DetectLoadCarriers_Request__callbacks = {
  "rc_reason_msgs::srv",
  "DetectLoadCarriers_Request",
  _DetectLoadCarriers_Request__cdr_serialize,
  _DetectLoadCarriers_Request__cdr_deserialize,
  _DetectLoadCarriers_Request__get_serialized_size,
  _DetectLoadCarriers_Request__max_serialized_size
};

static rosidl_message_type_support_t _DetectLoadCarriers_Request__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_DetectLoadCarriers_Request__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::DetectLoadCarriers_Request>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_DetectLoadCarriers_Request__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, DetectLoadCarriers_Request)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_DetectLoadCarriers_Request__handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include <limits>
// already included above
// #include <stdexcept>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
// already included above
// #include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace builtin_interfaces
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const builtin_interfaces::msg::Time &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  builtin_interfaces::msg::Time &);
size_t get_serialized_size(
  const builtin_interfaces::msg::Time &,
  size_t current_alignment);
size_t
max_serialized_size_Time(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace builtin_interfaces

namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::LoadCarrier &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::LoadCarrier &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::LoadCarrier &,
  size_t current_alignment);
size_t
max_serialized_size_LoadCarrier(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs

namespace rc_common_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_common_msgs::msg::ReturnCode &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_common_msgs::msg::ReturnCode &);
size_t get_serialized_size(
  const rc_common_msgs::msg::ReturnCode &,
  size_t current_alignment);
size_t
max_serialized_size_ReturnCode(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_common_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::srv::DetectLoadCarriers_Response & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: timestamp
  builtin_interfaces::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.timestamp,
    cdr);
  // Member: load_carriers
  {
    size_t size = ros_message.load_carriers.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.load_carriers[i],
        cdr);
    }
  }
  // Member: return_code
  rc_common_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.return_code,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::srv::DetectLoadCarriers_Response & ros_message)
{
  // Member: timestamp
  builtin_interfaces::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.timestamp);

  // Member: load_carriers
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.load_carriers.resize(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.load_carriers[i]);
    }
  }

  // Member: return_code
  rc_common_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.return_code);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::srv::DetectLoadCarriers_Response & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: timestamp

  current_alignment +=
    builtin_interfaces::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.timestamp, current_alignment);
  // Member: load_carriers
  {
    size_t array_size = ros_message.load_carriers.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.load_carriers[index], current_alignment);
    }
  }
  // Member: return_code

  current_alignment +=
    rc_common_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.return_code, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_DetectLoadCarriers_Response(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: timestamp
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        builtin_interfaces::msg::typesupport_fastrtps_cpp::max_serialized_size_Time(
        full_bounded, current_alignment);
    }
  }

  // Member: load_carriers
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_LoadCarrier(
        full_bounded, current_alignment);
    }
  }

  // Member: return_code
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_common_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_ReturnCode(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _DetectLoadCarriers_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::DetectLoadCarriers_Response *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _DetectLoadCarriers_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::srv::DetectLoadCarriers_Response *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _DetectLoadCarriers_Response__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::DetectLoadCarriers_Response *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _DetectLoadCarriers_Response__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_DetectLoadCarriers_Response(full_bounded, 0);
}

static message_type_support_callbacks_t _DetectLoadCarriers_Response__callbacks = {
  "rc_reason_msgs::srv",
  "DetectLoadCarriers_Response",
  _DetectLoadCarriers_Response__cdr_serialize,
  _DetectLoadCarriers_Response__cdr_deserialize,
  _DetectLoadCarriers_Response__get_serialized_size,
  _DetectLoadCarriers_Response__max_serialized_size
};

static rosidl_message_type_support_t _DetectLoadCarriers_Response__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_DetectLoadCarriers_Response__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::DetectLoadCarriers_Response>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_DetectLoadCarriers_Response__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, DetectLoadCarriers_Response)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_DetectLoadCarriers_Response__handle;
}

#ifdef __cplusplus
}
#endif

#include "rmw/error_handling.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support_decl.hpp"

namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

static service_type_support_callbacks_t _DetectLoadCarriers__callbacks = {
  "rc_reason_msgs::srv",
  "DetectLoadCarriers",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, DetectLoadCarriers_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, DetectLoadCarriers_Response)(),
};

static rosidl_service_type_support_t _DetectLoadCarriers__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_DetectLoadCarriers__callbacks,
  get_service_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_service_type_support_t *
get_service_type_support_handle<rc_reason_msgs::srv::DetectLoadCarriers>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_DetectLoadCarriers__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, DetectLoadCarriers)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_DetectLoadCarriers__handle;
}

#ifdef __cplusplus
}
#endif
