// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rc_reason_msgs:srv/SetHandEyeCalibrationPose.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/set_hand_eye_calibration_pose__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rc_reason_msgs/srv/detail/set_hand_eye_calibration_pose__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace geometry_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const geometry_msgs::msg::Pose &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  geometry_msgs::msg::Pose &);
size_t get_serialized_size(
  const geometry_msgs::msg::Pose &,
  size_t current_alignment);
size_t
max_serialized_size_Pose(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace geometry_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Request & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: slot
  cdr << ros_message.slot;
  // Member: pose
  geometry_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.pose,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::srv::SetHandEyeCalibrationPose_Request & ros_message)
{
  // Member: slot
  cdr >> ros_message.slot;

  // Member: pose
  geometry_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.pose);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Request & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: slot
  {
    size_t item_size = sizeof(ros_message.slot);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: pose

  current_alignment +=
    geometry_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.pose, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_SetHandEyeCalibrationPose_Request(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: slot
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: pose
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        geometry_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Pose(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _SetHandEyeCalibrationPose_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Request *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _SetHandEyeCalibrationPose_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::srv::SetHandEyeCalibrationPose_Request *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _SetHandEyeCalibrationPose_Request__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Request *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _SetHandEyeCalibrationPose_Request__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_SetHandEyeCalibrationPose_Request(full_bounded, 0);
}

static message_type_support_callbacks_t _SetHandEyeCalibrationPose_Request__callbacks = {
  "rc_reason_msgs::srv",
  "SetHandEyeCalibrationPose_Request",
  _SetHandEyeCalibrationPose_Request__cdr_serialize,
  _SetHandEyeCalibrationPose_Request__cdr_deserialize,
  _SetHandEyeCalibrationPose_Request__get_serialized_size,
  _SetHandEyeCalibrationPose_Request__max_serialized_size
};

static rosidl_message_type_support_t _SetHandEyeCalibrationPose_Request__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SetHandEyeCalibrationPose_Request__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::SetHandEyeCalibrationPose_Request>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SetHandEyeCalibrationPose_Request__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SetHandEyeCalibrationPose_Request)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SetHandEyeCalibrationPose_Request__handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include <limits>
// already included above
// #include <stdexcept>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
// already included above
// #include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Response & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: success
  cdr << (ros_message.success ? true : false);
  // Member: status
  cdr << ros_message.status;
  // Member: message
  cdr << ros_message.message;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::srv::SetHandEyeCalibrationPose_Response & ros_message)
{
  // Member: success
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.success = tmp ? true : false;
  }

  // Member: status
  cdr >> ros_message.status;

  // Member: message
  cdr >> ros_message.message;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Response & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: success
  {
    size_t item_size = sizeof(ros_message.success);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: status
  {
    size_t item_size = sizeof(ros_message.status);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: message
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.message.size() + 1);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_SetHandEyeCalibrationPose_Response(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: success
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: status
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: message
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  return current_alignment - initial_alignment;
}

static bool _SetHandEyeCalibrationPose_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Response *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _SetHandEyeCalibrationPose_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::srv::SetHandEyeCalibrationPose_Response *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _SetHandEyeCalibrationPose_Response__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SetHandEyeCalibrationPose_Response *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _SetHandEyeCalibrationPose_Response__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_SetHandEyeCalibrationPose_Response(full_bounded, 0);
}

static message_type_support_callbacks_t _SetHandEyeCalibrationPose_Response__callbacks = {
  "rc_reason_msgs::srv",
  "SetHandEyeCalibrationPose_Response",
  _SetHandEyeCalibrationPose_Response__cdr_serialize,
  _SetHandEyeCalibrationPose_Response__cdr_deserialize,
  _SetHandEyeCalibrationPose_Response__get_serialized_size,
  _SetHandEyeCalibrationPose_Response__max_serialized_size
};

static rosidl_message_type_support_t _SetHandEyeCalibrationPose_Response__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SetHandEyeCalibrationPose_Response__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::SetHandEyeCalibrationPose_Response>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SetHandEyeCalibrationPose_Response__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SetHandEyeCalibrationPose_Response)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SetHandEyeCalibrationPose_Response__handle;
}

#ifdef __cplusplus
}
#endif

#include "rmw/error_handling.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support_decl.hpp"

namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

static service_type_support_callbacks_t _SetHandEyeCalibrationPose__callbacks = {
  "rc_reason_msgs::srv",
  "SetHandEyeCalibrationPose",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SetHandEyeCalibrationPose_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SetHandEyeCalibrationPose_Response)(),
};

static rosidl_service_type_support_t _SetHandEyeCalibrationPose__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SetHandEyeCalibrationPose__callbacks,
  get_service_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_service_type_support_t *
get_service_type_support_handle<rc_reason_msgs::srv::SetHandEyeCalibrationPose>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SetHandEyeCalibrationPose__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SetHandEyeCalibrationPose)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SetHandEyeCalibrationPose__handle;
}

#ifdef __cplusplus
}
#endif
