// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rc_reason_msgs:srv/SilhouetteMatchDetectObject.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/silhouette_match_detect_object__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rc_reason_msgs/srv/detail/silhouette_match_detect_object__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::SilhouetteMatchObject &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::SilhouetteMatchObject &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::SilhouetteMatchObject &,
  size_t current_alignment);
size_t
max_serialized_size_SilhouetteMatchObject(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs

namespace geometry_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const geometry_msgs::msg::Pose &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  geometry_msgs::msg::Pose &);
size_t get_serialized_size(
  const geometry_msgs::msg::Pose &,
  size_t current_alignment);
size_t
max_serialized_size_Pose(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace geometry_msgs

namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::CollisionDetection &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::CollisionDetection &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::CollisionDetection &,
  size_t current_alignment);
size_t
max_serialized_size_CollisionDetection(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: object_to_detect
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.object_to_detect,
    cdr);
  // Member: offset
  cdr << ros_message.offset;
  // Member: pose_frame
  cdr << ros_message.pose_frame;
  // Member: robot_pose
  geometry_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.robot_pose,
    cdr);
  // Member: load_carrier_id
  cdr << ros_message.load_carrier_id;
  // Member: collision_detection
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.collision_detection,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request & ros_message)
{
  // Member: object_to_detect
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.object_to_detect);

  // Member: offset
  cdr >> ros_message.offset;

  // Member: pose_frame
  cdr >> ros_message.pose_frame;

  // Member: robot_pose
  geometry_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.robot_pose);

  // Member: load_carrier_id
  cdr >> ros_message.load_carrier_id;

  // Member: collision_detection
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.collision_detection);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: object_to_detect

  current_alignment +=
    rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.object_to_detect, current_alignment);
  // Member: offset
  {
    size_t item_size = sizeof(ros_message.offset);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: pose_frame
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.pose_frame.size() + 1);
  // Member: robot_pose

  current_alignment +=
    geometry_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.robot_pose, current_alignment);
  // Member: load_carrier_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.load_carrier_id.size() + 1);
  // Member: collision_detection

  current_alignment +=
    rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.collision_detection, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_SilhouetteMatchDetectObject_Request(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: object_to_detect
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SilhouetteMatchObject(
        full_bounded, current_alignment);
    }
  }

  // Member: offset
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: pose_frame
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: robot_pose
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        geometry_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Pose(
        full_bounded, current_alignment);
    }
  }

  // Member: load_carrier_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: collision_detection
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_CollisionDetection(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _SilhouetteMatchDetectObject_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _SilhouetteMatchDetectObject_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _SilhouetteMatchDetectObject_Request__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _SilhouetteMatchDetectObject_Request__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_SilhouetteMatchDetectObject_Request(full_bounded, 0);
}

static message_type_support_callbacks_t _SilhouetteMatchDetectObject_Request__callbacks = {
  "rc_reason_msgs::srv",
  "SilhouetteMatchDetectObject_Request",
  _SilhouetteMatchDetectObject_Request__cdr_serialize,
  _SilhouetteMatchDetectObject_Request__cdr_deserialize,
  _SilhouetteMatchDetectObject_Request__get_serialized_size,
  _SilhouetteMatchDetectObject_Request__max_serialized_size
};

static rosidl_message_type_support_t _SilhouetteMatchDetectObject_Request__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SilhouetteMatchDetectObject_Request__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SilhouetteMatchDetectObject_Request__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SilhouetteMatchDetectObject_Request)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SilhouetteMatchDetectObject_Request__handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include <limits>
// already included above
// #include <stdexcept>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
// already included above
// #include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace builtin_interfaces
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const builtin_interfaces::msg::Time &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  builtin_interfaces::msg::Time &);
size_t get_serialized_size(
  const builtin_interfaces::msg::Time &,
  size_t current_alignment);
size_t
max_serialized_size_Time(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace builtin_interfaces

namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::Match &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::Match &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::Match &,
  size_t current_alignment);
size_t
max_serialized_size_Match(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::Grasp &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::Grasp &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::Grasp &,
  size_t current_alignment);
size_t
max_serialized_size_Grasp(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::LoadCarrier &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::LoadCarrier &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::LoadCarrier &,
  size_t current_alignment);
size_t
max_serialized_size_LoadCarrier(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs

namespace rc_common_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_common_msgs::msg::ReturnCode &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_common_msgs::msg::ReturnCode &);
size_t get_serialized_size(
  const rc_common_msgs::msg::ReturnCode &,
  size_t current_alignment);
size_t
max_serialized_size_ReturnCode(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_common_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: timestamp
  builtin_interfaces::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.timestamp,
    cdr);
  // Member: matches
  {
    size_t size = ros_message.matches.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.matches[i],
        cdr);
    }
  }
  // Member: grasps
  {
    size_t size = ros_message.grasps.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.grasps[i],
        cdr);
    }
  }
  // Member: load_carriers
  {
    size_t size = ros_message.load_carriers.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.load_carriers[i],
        cdr);
    }
  }
  // Member: return_code
  rc_common_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.return_code,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response & ros_message)
{
  // Member: timestamp
  builtin_interfaces::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.timestamp);

  // Member: matches
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.matches.resize(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.matches[i]);
    }
  }

  // Member: grasps
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.grasps.resize(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.grasps[i]);
    }
  }

  // Member: load_carriers
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.load_carriers.resize(size);
    for (size_t i = 0; i < size; i++) {
      rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.load_carriers[i]);
    }
  }

  // Member: return_code
  rc_common_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.return_code);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: timestamp

  current_alignment +=
    builtin_interfaces::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.timestamp, current_alignment);
  // Member: matches
  {
    size_t array_size = ros_message.matches.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.matches[index], current_alignment);
    }
  }
  // Member: grasps
  {
    size_t array_size = ros_message.grasps.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.grasps[index], current_alignment);
    }
  }
  // Member: load_carriers
  {
    size_t array_size = ros_message.load_carriers.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.load_carriers[index], current_alignment);
    }
  }
  // Member: return_code

  current_alignment +=
    rc_common_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.return_code, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_SilhouetteMatchDetectObject_Response(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: timestamp
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        builtin_interfaces::msg::typesupport_fastrtps_cpp::max_serialized_size_Time(
        full_bounded, current_alignment);
    }
  }

  // Member: matches
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Match(
        full_bounded, current_alignment);
    }
  }

  // Member: grasps
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Grasp(
        full_bounded, current_alignment);
    }
  }

  // Member: load_carriers
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_LoadCarrier(
        full_bounded, current_alignment);
    }
  }

  // Member: return_code
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_common_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_ReturnCode(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _SilhouetteMatchDetectObject_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _SilhouetteMatchDetectObject_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _SilhouetteMatchDetectObject_Response__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _SilhouetteMatchDetectObject_Response__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_SilhouetteMatchDetectObject_Response(full_bounded, 0);
}

static message_type_support_callbacks_t _SilhouetteMatchDetectObject_Response__callbacks = {
  "rc_reason_msgs::srv",
  "SilhouetteMatchDetectObject_Response",
  _SilhouetteMatchDetectObject_Response__cdr_serialize,
  _SilhouetteMatchDetectObject_Response__cdr_deserialize,
  _SilhouetteMatchDetectObject_Response__get_serialized_size,
  _SilhouetteMatchDetectObject_Response__max_serialized_size
};

static rosidl_message_type_support_t _SilhouetteMatchDetectObject_Response__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SilhouetteMatchDetectObject_Response__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SilhouetteMatchDetectObject_Response__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SilhouetteMatchDetectObject_Response)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SilhouetteMatchDetectObject_Response__handle;
}

#ifdef __cplusplus
}
#endif

#include "rmw/error_handling.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support_decl.hpp"

namespace rc_reason_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

static service_type_support_callbacks_t _SilhouetteMatchDetectObject__callbacks = {
  "rc_reason_msgs::srv",
  "SilhouetteMatchDetectObject",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SilhouetteMatchDetectObject_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SilhouetteMatchDetectObject_Response)(),
};

static rosidl_service_type_support_t _SilhouetteMatchDetectObject__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SilhouetteMatchDetectObject__callbacks,
  get_service_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_service_type_support_t *
get_service_type_support_handle<rc_reason_msgs::srv::SilhouetteMatchDetectObject>()
{
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SilhouetteMatchDetectObject__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, srv, SilhouetteMatchDetectObject)() {
  return &rc_reason_msgs::srv::typesupport_fastrtps_cpp::_SilhouetteMatchDetectObject__handle;
}

#ifdef __cplusplus
}
#endif
