// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from rc_reason_msgs:msg/CollisionDetection.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/collision_detection__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/msg/detail/collision_detection__struct.h"
#include "rc_reason_msgs/msg/detail/collision_detection__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "geometry_msgs/msg/detail/point__functions.h"  // pre_grasp_offset
#include "rosidl_runtime_c/string.h"  // gripper_id
#include "rosidl_runtime_c/string_functions.h"  // gripper_id

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_geometry_msgs__msg__Point(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_geometry_msgs__msg__Point(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Point)();


using _CollisionDetection__ros_msg_type = rc_reason_msgs__msg__CollisionDetection;

static bool _CollisionDetection__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _CollisionDetection__ros_msg_type * ros_message = static_cast<const _CollisionDetection__ros_msg_type *>(untyped_ros_message);
  // Field name: gripper_id
  {
    const rosidl_runtime_c__String * str = &ros_message->gripper_id;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: pre_grasp_offset
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Point
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->pre_grasp_offset, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _CollisionDetection__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _CollisionDetection__ros_msg_type * ros_message = static_cast<_CollisionDetection__ros_msg_type *>(untyped_ros_message);
  // Field name: gripper_id
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->gripper_id.data) {
      rosidl_runtime_c__String__init(&ros_message->gripper_id);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->gripper_id,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'gripper_id'\n");
      return false;
    }
  }

  // Field name: pre_grasp_offset
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Point
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->pre_grasp_offset))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__msg__CollisionDetection(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _CollisionDetection__ros_msg_type * ros_message = static_cast<const _CollisionDetection__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name gripper_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->gripper_id.size + 1);
  // field.name pre_grasp_offset

  current_alignment += get_serialized_size_geometry_msgs__msg__Point(
    &(ros_message->pre_grasp_offset), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _CollisionDetection__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__msg__CollisionDetection(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__msg__CollisionDetection(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: gripper_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: pre_grasp_offset
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_geometry_msgs__msg__Point(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _CollisionDetection__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__msg__CollisionDetection(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_CollisionDetection = {
  "rc_reason_msgs::msg",
  "CollisionDetection",
  _CollisionDetection__cdr_serialize,
  _CollisionDetection__cdr_deserialize,
  _CollisionDetection__get_serialized_size,
  _CollisionDetection__max_serialized_size
};

static rosidl_message_type_support_t _CollisionDetection__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_CollisionDetection,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, msg, CollisionDetection)() {
  return &_CollisionDetection__type_support;
}

#if defined(__cplusplus)
}
#endif
