// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from rc_reason_msgs:srv/CalibrateBasePlane.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/calibrate_base_plane__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/detail/calibrate_base_plane__struct.h"
#include "rc_reason_msgs/srv/detail/calibrate_base_plane__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "geometry_msgs/msg/detail/pose__functions.h"  // robot_pose
#include "rosidl_runtime_c/string.h"  // plane_estimation_method, pose_frame, region_of_interest_2d_id, stereo_plane_preference
#include "rosidl_runtime_c/string_functions.h"  // plane_estimation_method, pose_frame, region_of_interest_2d_id, stereo_plane_preference
#include "shape_msgs/msg/detail/plane__functions.h"  // plane

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_geometry_msgs__msg__Pose(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_geometry_msgs__msg__Pose(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose)();
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_shape_msgs__msg__Plane(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_shape_msgs__msg__Plane(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, shape_msgs, msg, Plane)();


using _CalibrateBasePlane_Request__ros_msg_type = rc_reason_msgs__srv__CalibrateBasePlane_Request;

static bool _CalibrateBasePlane_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _CalibrateBasePlane_Request__ros_msg_type * ros_message = static_cast<const _CalibrateBasePlane_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: pose_frame
  {
    const rosidl_runtime_c__String * str = &ros_message->pose_frame;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: robot_pose
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->robot_pose, cdr))
    {
      return false;
    }
  }

  // Field name: plane_estimation_method
  {
    const rosidl_runtime_c__String * str = &ros_message->plane_estimation_method;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: stereo_plane_preference
  {
    const rosidl_runtime_c__String * str = &ros_message->stereo_plane_preference;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: region_of_interest_2d_id
  {
    const rosidl_runtime_c__String * str = &ros_message->region_of_interest_2d_id;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: offset
  {
    cdr << ros_message->offset;
  }

  // Field name: plane
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, shape_msgs, msg, Plane
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->plane, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _CalibrateBasePlane_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _CalibrateBasePlane_Request__ros_msg_type * ros_message = static_cast<_CalibrateBasePlane_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: pose_frame
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->pose_frame.data) {
      rosidl_runtime_c__String__init(&ros_message->pose_frame);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->pose_frame,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'pose_frame'\n");
      return false;
    }
  }

  // Field name: robot_pose
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Pose
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->robot_pose))
    {
      return false;
    }
  }

  // Field name: plane_estimation_method
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->plane_estimation_method.data) {
      rosidl_runtime_c__String__init(&ros_message->plane_estimation_method);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->plane_estimation_method,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'plane_estimation_method'\n");
      return false;
    }
  }

  // Field name: stereo_plane_preference
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->stereo_plane_preference.data) {
      rosidl_runtime_c__String__init(&ros_message->stereo_plane_preference);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->stereo_plane_preference,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'stereo_plane_preference'\n");
      return false;
    }
  }

  // Field name: region_of_interest_2d_id
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->region_of_interest_2d_id.data) {
      rosidl_runtime_c__String__init(&ros_message->region_of_interest_2d_id);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->region_of_interest_2d_id,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'region_of_interest_2d_id'\n");
      return false;
    }
  }

  // Field name: offset
  {
    cdr >> ros_message->offset;
  }

  // Field name: plane
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, shape_msgs, msg, Plane
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->plane))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Request(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _CalibrateBasePlane_Request__ros_msg_type * ros_message = static_cast<const _CalibrateBasePlane_Request__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name pose_frame
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->pose_frame.size + 1);
  // field.name robot_pose

  current_alignment += get_serialized_size_geometry_msgs__msg__Pose(
    &(ros_message->robot_pose), current_alignment);
  // field.name plane_estimation_method
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->plane_estimation_method.size + 1);
  // field.name stereo_plane_preference
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->stereo_plane_preference.size + 1);
  // field.name region_of_interest_2d_id
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->region_of_interest_2d_id.size + 1);
  // field.name offset
  {
    size_t item_size = sizeof(ros_message->offset);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name plane

  current_alignment += get_serialized_size_shape_msgs__msg__Plane(
    &(ros_message->plane), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _CalibrateBasePlane_Request__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Request(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Request(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: pose_frame
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: robot_pose
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_geometry_msgs__msg__Pose(
        full_bounded, current_alignment);
    }
  }
  // member: plane_estimation_method
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: stereo_plane_preference
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: region_of_interest_2d_id
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: offset
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }
  // member: plane
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_shape_msgs__msg__Plane(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _CalibrateBasePlane_Request__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Request(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_CalibrateBasePlane_Request = {
  "rc_reason_msgs::srv",
  "CalibrateBasePlane_Request",
  _CalibrateBasePlane_Request__cdr_serialize,
  _CalibrateBasePlane_Request__cdr_deserialize,
  _CalibrateBasePlane_Request__get_serialized_size,
  _CalibrateBasePlane_Request__max_serialized_size
};

static rosidl_message_type_support_t _CalibrateBasePlane_Request__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_CalibrateBasePlane_Request,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, CalibrateBasePlane_Request)() {
  return &_CalibrateBasePlane_Request__type_support;
}

#if defined(__cplusplus)
}
#endif

// already included above
// #include <cassert>
// already included above
// #include <limits>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
// already included above
// #include "rc_reason_msgs/srv/detail/calibrate_base_plane__struct.h"
// already included above
// #include "rc_reason_msgs/srv/detail/calibrate_base_plane__functions.h"
// already included above
// #include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "builtin_interfaces/msg/detail/time__functions.h"  // timestamp
#include "rc_common_msgs/msg/detail/return_code__functions.h"  // return_code
// already included above
// #include "rosidl_runtime_c/string.h"  // pose_frame
// already included above
// #include "rosidl_runtime_c/string_functions.h"  // pose_frame
// already included above
// #include "shape_msgs/msg/detail/plane__functions.h"  // plane

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_builtin_interfaces__msg__Time(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_builtin_interfaces__msg__Time(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time)();
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_rc_common_msgs__msg__ReturnCode(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_rc_common_msgs__msg__ReturnCode(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode)();
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_shape_msgs__msg__Plane(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_shape_msgs__msg__Plane(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, shape_msgs, msg, Plane)();


using _CalibrateBasePlane_Response__ros_msg_type = rc_reason_msgs__srv__CalibrateBasePlane_Response;

static bool _CalibrateBasePlane_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _CalibrateBasePlane_Response__ros_msg_type * ros_message = static_cast<const _CalibrateBasePlane_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: timestamp
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->timestamp, cdr))
    {
      return false;
    }
  }

  // Field name: pose_frame
  {
    const rosidl_runtime_c__String * str = &ros_message->pose_frame;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: plane
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, shape_msgs, msg, Plane
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->plane, cdr))
    {
      return false;
    }
  }

  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->return_code, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _CalibrateBasePlane_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _CalibrateBasePlane_Response__ros_msg_type * ros_message = static_cast<_CalibrateBasePlane_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: timestamp
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, builtin_interfaces, msg, Time
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->timestamp))
    {
      return false;
    }
  }

  // Field name: pose_frame
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->pose_frame.data) {
      rosidl_runtime_c__String__init(&ros_message->pose_frame);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->pose_frame,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'pose_frame'\n");
      return false;
    }
  }

  // Field name: plane
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, shape_msgs, msg, Plane
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->plane))
    {
      return false;
    }
  }

  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->return_code))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Response(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _CalibrateBasePlane_Response__ros_msg_type * ros_message = static_cast<const _CalibrateBasePlane_Response__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name timestamp

  current_alignment += get_serialized_size_builtin_interfaces__msg__Time(
    &(ros_message->timestamp), current_alignment);
  // field.name pose_frame
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->pose_frame.size + 1);
  // field.name plane

  current_alignment += get_serialized_size_shape_msgs__msg__Plane(
    &(ros_message->plane), current_alignment);
  // field.name return_code

  current_alignment += get_serialized_size_rc_common_msgs__msg__ReturnCode(
    &(ros_message->return_code), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _CalibrateBasePlane_Response__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Response(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Response(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: timestamp
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_builtin_interfaces__msg__Time(
        full_bounded, current_alignment);
    }
  }
  // member: pose_frame
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: plane
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_shape_msgs__msg__Plane(
        full_bounded, current_alignment);
    }
  }
  // member: return_code
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_common_msgs__msg__ReturnCode(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _CalibrateBasePlane_Response__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__CalibrateBasePlane_Response(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_CalibrateBasePlane_Response = {
  "rc_reason_msgs::srv",
  "CalibrateBasePlane_Response",
  _CalibrateBasePlane_Response__cdr_serialize,
  _CalibrateBasePlane_Response__cdr_deserialize,
  _CalibrateBasePlane_Response__get_serialized_size,
  _CalibrateBasePlane_Response__max_serialized_size
};

static rosidl_message_type_support_t _CalibrateBasePlane_Response__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_CalibrateBasePlane_Response,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, CalibrateBasePlane_Response)() {
  return &_CalibrateBasePlane_Response__type_support;
}

#if defined(__cplusplus)
}
#endif

#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/calibrate_base_plane.h"

#if defined(__cplusplus)
extern "C"
{
#endif

static service_type_support_callbacks_t CalibrateBasePlane__callbacks = {
  "rc_reason_msgs::srv",
  "CalibrateBasePlane",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, CalibrateBasePlane_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, CalibrateBasePlane_Response)(),
};

static rosidl_service_type_support_t CalibrateBasePlane__handle = {
  rosidl_typesupport_fastrtps_c__identifier,
  &CalibrateBasePlane__callbacks,
  get_service_typesupport_handle_function,
};

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, CalibrateBasePlane)() {
  return &CalibrateBasePlane__handle;
}

#if defined(__cplusplus)
}
#endif
