// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from rc_reason_msgs:srv/DeleteLoadCarriers.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/delete_load_carriers__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/detail/delete_load_carriers__struct.h"
#include "rc_reason_msgs/srv/detail/delete_load_carriers__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rosidl_runtime_c/string.h"  // load_carrier_ids
#include "rosidl_runtime_c/string_functions.h"  // load_carrier_ids

// forward declare type support functions


using _DeleteLoadCarriers_Request__ros_msg_type = rc_reason_msgs__srv__DeleteLoadCarriers_Request;

static bool _DeleteLoadCarriers_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _DeleteLoadCarriers_Request__ros_msg_type * ros_message = static_cast<const _DeleteLoadCarriers_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: load_carrier_ids
  {
    size_t size = ros_message->load_carrier_ids.size;
    auto array_ptr = ros_message->load_carrier_ids.data;
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; ++i) {
      const rosidl_runtime_c__String * str = &array_ptr[i];
      if (str->capacity == 0 || str->capacity <= str->size) {
        fprintf(stderr, "string capacity not greater than size\n");
        return false;
      }
      if (str->data[str->size] != '\0') {
        fprintf(stderr, "string not null-terminated\n");
        return false;
      }
      cdr << str->data;
    }
  }

  return true;
}

static bool _DeleteLoadCarriers_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _DeleteLoadCarriers_Request__ros_msg_type * ros_message = static_cast<_DeleteLoadCarriers_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: load_carrier_ids
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->load_carrier_ids.data) {
      rosidl_runtime_c__String__Sequence__fini(&ros_message->load_carrier_ids);
    }
    if (!rosidl_runtime_c__String__Sequence__init(&ros_message->load_carrier_ids, size)) {
      fprintf(stderr, "failed to create array for field 'load_carrier_ids'");
      return false;
    }
    auto array_ptr = ros_message->load_carrier_ids.data;
    for (size_t i = 0; i < size; ++i) {
      std::string tmp;
      cdr >> tmp;
      auto & ros_i = array_ptr[i];
      if (!ros_i.data) {
        rosidl_runtime_c__String__init(&ros_i);
      }
      bool succeeded = rosidl_runtime_c__String__assign(
        &ros_i,
        tmp.c_str());
      if (!succeeded) {
        fprintf(stderr, "failed to assign string into field 'load_carrier_ids'\n");
        return false;
      }
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Request(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _DeleteLoadCarriers_Request__ros_msg_type * ros_message = static_cast<const _DeleteLoadCarriers_Request__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name load_carrier_ids
  {
    size_t array_size = ros_message->load_carrier_ids.size;
    auto array_ptr = ros_message->load_carrier_ids.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (array_ptr[index].size + 1);
    }
  }

  return current_alignment - initial_alignment;
}

static uint32_t _DeleteLoadCarriers_Request__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Request(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Request(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: load_carrier_ids
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _DeleteLoadCarriers_Request__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Request(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_DeleteLoadCarriers_Request = {
  "rc_reason_msgs::srv",
  "DeleteLoadCarriers_Request",
  _DeleteLoadCarriers_Request__cdr_serialize,
  _DeleteLoadCarriers_Request__cdr_deserialize,
  _DeleteLoadCarriers_Request__get_serialized_size,
  _DeleteLoadCarriers_Request__max_serialized_size
};

static rosidl_message_type_support_t _DeleteLoadCarriers_Request__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_DeleteLoadCarriers_Request,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DeleteLoadCarriers_Request)() {
  return &_DeleteLoadCarriers_Request__type_support;
}

#if defined(__cplusplus)
}
#endif

// already included above
// #include <cassert>
// already included above
// #include <limits>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
// already included above
// #include "rc_reason_msgs/srv/detail/delete_load_carriers__struct.h"
// already included above
// #include "rc_reason_msgs/srv/detail/delete_load_carriers__functions.h"
// already included above
// #include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rc_common_msgs/msg/detail/return_code__functions.h"  // return_code

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t get_serialized_size_rc_common_msgs__msg__ReturnCode(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
size_t max_serialized_size_rc_common_msgs__msg__ReturnCode(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_rc_reason_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode)();


using _DeleteLoadCarriers_Response__ros_msg_type = rc_reason_msgs__srv__DeleteLoadCarriers_Response;

static bool _DeleteLoadCarriers_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _DeleteLoadCarriers_Response__ros_msg_type * ros_message = static_cast<const _DeleteLoadCarriers_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->return_code, cdr))
    {
      return false;
    }
  }

  return true;
}

static bool _DeleteLoadCarriers_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _DeleteLoadCarriers_Response__ros_msg_type * ros_message = static_cast<_DeleteLoadCarriers_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: return_code
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, rc_common_msgs, msg, ReturnCode
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->return_code))
    {
      return false;
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t get_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Response(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _DeleteLoadCarriers_Response__ros_msg_type * ros_message = static_cast<const _DeleteLoadCarriers_Response__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name return_code

  current_alignment += get_serialized_size_rc_common_msgs__msg__ReturnCode(
    &(ros_message->return_code), current_alignment);

  return current_alignment - initial_alignment;
}

static uint32_t _DeleteLoadCarriers_Response__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Response(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_rc_reason_msgs
size_t max_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Response(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: return_code
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_rc_common_msgs__msg__ReturnCode(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _DeleteLoadCarriers_Response__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_rc_reason_msgs__srv__DeleteLoadCarriers_Response(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_DeleteLoadCarriers_Response = {
  "rc_reason_msgs::srv",
  "DeleteLoadCarriers_Response",
  _DeleteLoadCarriers_Response__cdr_serialize,
  _DeleteLoadCarriers_Response__cdr_deserialize,
  _DeleteLoadCarriers_Response__get_serialized_size,
  _DeleteLoadCarriers_Response__max_serialized_size
};

static rosidl_message_type_support_t _DeleteLoadCarriers_Response__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_DeleteLoadCarriers_Response,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DeleteLoadCarriers_Response)() {
  return &_DeleteLoadCarriers_Response__type_support;
}

#if defined(__cplusplus)
}
#endif

#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rc_reason_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "rc_reason_msgs/srv/delete_load_carriers.h"

#if defined(__cplusplus)
extern "C"
{
#endif

static service_type_support_callbacks_t DeleteLoadCarriers__callbacks = {
  "rc_reason_msgs::srv",
  "DeleteLoadCarriers",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DeleteLoadCarriers_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DeleteLoadCarriers_Response)(),
};

static rosidl_service_type_support_t DeleteLoadCarriers__handle = {
  rosidl_typesupport_fastrtps_c__identifier,
  &DeleteLoadCarriers__callbacks,
  get_service_typesupport_handle_function,
};

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, rc_reason_msgs, srv, DeleteLoadCarriers)() {
  return &DeleteLoadCarriers__handle;
}

#if defined(__cplusplus)
}
#endif
