// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rc_reason_msgs:msg/RangeBox.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/range_box__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rc_reason_msgs/msg/detail/range_box__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::Box &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::Box &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::Box &,
  size_t current_alignment);
size_t
max_serialized_size_Box(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const rc_reason_msgs::msg::Box &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  rc_reason_msgs::msg::Box &);
size_t get_serialized_size(
  const rc_reason_msgs::msg::Box &,
  size_t current_alignment);
size_t
max_serialized_size_Box(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace rc_reason_msgs


namespace rc_reason_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_serialize(
  const rc_reason_msgs::msg::RangeBox & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: min_dimensions
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.min_dimensions,
    cdr);
  // Member: max_dimensions
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.max_dimensions,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rc_reason_msgs::msg::RangeBox & ros_message)
{
  // Member: min_dimensions
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.min_dimensions);

  // Member: max_dimensions
  rc_reason_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.max_dimensions);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
get_serialized_size(
  const rc_reason_msgs::msg::RangeBox & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: min_dimensions

  current_alignment +=
    rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.min_dimensions, current_alignment);
  // Member: max_dimensions

  current_alignment +=
    rc_reason_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.max_dimensions, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rc_reason_msgs
max_serialized_size_RangeBox(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: min_dimensions
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Box(
        full_bounded, current_alignment);
    }
  }

  // Member: max_dimensions
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        rc_reason_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Box(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _RangeBox__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::msg::RangeBox *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _RangeBox__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rc_reason_msgs::msg::RangeBox *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _RangeBox__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rc_reason_msgs::msg::RangeBox *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _RangeBox__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_RangeBox(full_bounded, 0);
}

static message_type_support_callbacks_t _RangeBox__callbacks = {
  "rc_reason_msgs::msg",
  "RangeBox",
  _RangeBox__cdr_serialize,
  _RangeBox__cdr_deserialize,
  _RangeBox__get_serialized_size,
  _RangeBox__max_serialized_size
};

static rosidl_message_type_support_t _RangeBox__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_RangeBox__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rc_reason_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::msg::RangeBox>()
{
  return &rc_reason_msgs::msg::typesupport_fastrtps_cpp::_RangeBox__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rc_reason_msgs, msg, RangeBox)() {
  return &rc_reason_msgs::msg::typesupport_fastrtps_cpp::_RangeBox__handle;
}

#ifdef __cplusplus
}
#endif
